#!/bin/sh

# Suspend script, called by the modified
# apm to run commands on a suspend.
#
# This has a timeout safety feature, so
# that if the commands do not finish 
# running in $timeout seconds then all
# suspend command are cancelled, allowing
# the Zaurus to suspend.
# Because of this any cruial and stable
# commands should be given a lower
# filename in /etc/apm.d/suspend.d so
# that they get run first.

timeout=20

# Call the script that deals with a timeout
# in the background
/usr/local/bin/susp-timeout $timeout &

# Call the script that runs the actual
# suspend commands. 
# Keep this in the foreground so that the
# Zaurus does not suspend until it exits
/usr/local/bin/susp-cmds
 
