#

inode=0

parse() {
    #echo $1 $3 $4
    if [ $inode != $1 ]; then
	inode=$1
	src=$4
	depth=$3
    else
	make_link $src $depth $4 $3
    fi
}

make_link() {
    if [ $2 = $4 ]; then
	# same directory depth
        d1=`dirname $1`
        d2=`dirname $3`
	if [ $d1 = $d2 ]; then
	    # a/b/x1 -> a/b/x2
	    (cd $d2; rm -rf `basename $3`; ln -s `basename $1` `basename $3`)
	    return
	fi 
        d21=`dirname $d1`
        d22=`dirname $d2`
	if [ $d21 = $d22 ]; then
	    # a/b/x1 -> a/c/x2
	    (cd $d2; rm -rf `basename $3`; ln -s ../`basename $d1`/`basename $1` `basename $3`)
	    return
	fi 
    elif [ `expr $2 \> $4` = 1 ]; then
	if [ `expr $2 - $4 \<= 1` = 1 ]; then
	    d1=`dir_name $1 2`
	    d2=`dir_name $3 1`
	    if [ $d1 = $d2 ]; then
		# a/b/c/x1 -> a/b/x2
		d1=`dirname $1`
		d1=`basename $d1`
	        (cd `dirname $3`; rm -rf `basename $3`; ln -s $d1/`basename $1` `basename $3`)
	        return;
	    fi
            d21=`dirname $d1`
            d22=`dirname $d2`
	    if [ $d21 = $d22 ]; then
		# a/b/c/x1 -> a/d/x2
		d1=`dirname $1`
		d2=$d1
		d1=`basename $d1`
		d2=`dirname $d2`
		d2=`basename $d2`
	        (cd `dirname $3`; rm -rf `basename $3`; ln -s ../$d2/$d1/`basename $1` `basename $3`)
	        return;
	    fi 
	elif [ `expr $2 - $4 \<= 2` = 1 ]; then
	    d1=`dir_name $1 3`
	    d2=`dir_name $3 1`
	    if [ $d1 = $d2 ]; then
		# a/b/c/x1 -> a/x2
		d1=`dirname $1`
		d2=$d1
		d1=`basename $d1`
		d2=`dirname $d2`
		d2=`basename $d2`
	        (cd `dirname $3`; rm -rf `basename $3`; ln -s $d2/$d1/`basename $1` `basename $3`)
	        return;
	    fi
	fi
    fi
    echo !!! not support !!!
    echo " - $1"
    echo " - $3"
    exit 1
}

dir_name() {
    dir=$1
    j=1
    while [ `expr $j \<= $2` = 1 ];
    do
	dir=`dirname $dir`
        j=`expr $j + 1`
    done
    echo $dir
}

#main
if [ "$1" = "" ]; then
    echo "usage: $0 <root fs directory>"
    exit 1
fi
cd $1

for i in `find . \! -links 1 \! -type d -printf "%i!%n!%d!%P\n" | sort -r`;
do
    parse `echo $i | sed -e "s/!/ /g"`
done

exit 0
