#!/bin/sh

export NVERSION=`date +%H%M%d%m%y`

#MODELS=SL-C3100

#MODELS="SL-C1000
#SL-C3100"

MODELS="SL-C1000
SL-C3100
SL-C700
SL-C750
SL-C760
SL-C860"

#MODELS="SL-C700
#SL-C750
#SL-C760
#SL-C860"
              
#MODELS=SL-C760
#MODELS=SL-C1000

#MODELS="SL-C760
#SL-C1000
#SL-C3100"

HOME_DIR=`pwd`
BASE_DIR="$HOME_DIR/base"
BUILD_DIR="$HOME_DIR/build"

for ZMODEL in $MODELS
do
    echo "Preparing build directory..."
    rm -rf $BUILD_DIR/*

    echo "Copying common files..."
    [ -d $BASE_DIR/dev ] && cp -Rfp $BASE_DIR/dev $BUILD_DIR
    [ -d $BASE_DIR/home ] && cp -Rfp $BASE_DIR/home $BUILD_DIR
    [ -d $BASE_DIR/var ] && cp -Rfp $BASE_DIR/var $BUILD_DIR
    [ -d $BASE_DIR/root_cramfs ] && cp -Rfp $BASE_DIR/root_cramfs $BUILD_DIR
    [ -d $BASE_DIR/root_jffs2 ] && cp -Rfp $BASE_DIR/root_jffs2 $BUILD_DIR

    export ZMODEL
    if [ "$ZMODEL" = "SL-C1000" -o "$ZMODEL" = "SL-C3000" -o "$ZMODEL" = "SL-C3100" -o "$ZMODEL" = "SL-C3500" ]; then
	export KERNEL_VERSION="2.4.20"
    else
	export KERNEL_VERSION="2.4.18-rmk7-pxa3-embedix"
    fi	

    # TODO:  create common directory for all C7x0/C860 devices!!!    
    echo "Copying kernel-specific common files..."
    [ -d $BASE_DIR-$KERNEL_VERSION/dev ] && cp -Rfp $BASE_DIR-$KERNEL_VERSION/dev $BUILD_DIR
    [ -d $BASE_DIR-$KERNEL_VERSION/home ] && cp -Rfp $BASE_DIR-$KERNEL_VERSION/home $BUILD_DIR
    [ -d $BASE_DIR-$KERNEL_VERSION/var ] && cp -Rfp $BASE_DIR-$KERNEL_VERSION/var $BUILD_DIR
    [ -d $BASE_DIR-$KERNEL_VERSION/root_cramfs ] && cp -Rfp $BASE_DIR-$KERNEL_VERSION/root_cramfs $BUILD_DIR
    [ -d $BASE_DIR-$KERNEL_VERSION/root_jffs2 ] && cp -Rfp $BASE_DIR-$KERNEL_VERSION/root_jffs2 $BUILD_DIR
    
    echo "Copying device-specific files..."
    [ -d $HOME_DIR/$ZMODEL/dev ] && cp -Rfp $HOME_DIR/$ZMODEL/dev $BUILD_DIR
    [ -d $HOME_DIR/$ZMODEL/home ] && cp -Rfp $HOME_DIR/$ZMODEL/home $BUILD_DIR
    [ -d $HOME_DIR/$ZMODEL/var ] && cp -Rfp $HOME_DIR/$ZMODEL/var $BUILD_DIR
    [ -d $HOME_DIR/$ZMODEL/root_cramfs ] && cp -Rfp $HOME_DIR/$ZMODEL/root_cramfs $BUILD_DIR
    [ -d $HOME_DIR/$ZMODEL/root_jffs2 ] && cp -Rfp $HOME_DIR/$ZMODEL/root_jffs2 $BUILD_DIR
    
    echo "Copying kernel modules $KERNEL_VERSION..."
    if [ -d $HOME_DIR/$ZMODEL/root_jffs2/lib/modules.rom/$KERNEL_VERSION ]; then
	rm -rf $BUILD_DIR/root_jffs2/lib/modules.rom
	mkdir -p $BUILD_DIR/root_jffs2/lib/modules.rom
	
	
	[ -d $BASE_DIR-$KERNEL_VERSION/root_jffs2/lib/modules.rom/$KERNEL_VERSION ] && \
	    cp -Rfp $BASE_DIR-$KERNEL_VERSION/root_jffs2/lib/modules.rom/$KERNEL_VERSION $BUILD_DIR/root_jffs2/lib/modules.rom/
	    
	[ -d $HOME_DIR/$ZMODEL/root_jffs2/lib/modules.rom/$KERNEL_VERSION ] && \
	    cp -Rfp $HOME_DIR/$ZMODEL/root_jffs2/lib/modules.rom/$KERNEL_VERSION $BUILD_DIR/root_jffs2/lib/modules.rom/
    fi
    
    
    [ -f $HOME_DIR/$ZMODEL/kernel/zImage.bin ] && cp -Rf $HOME_DIR/$ZMODEL/kernel/zImage.bin $HOME_DIR/bin/tools/kernel-$ZMODEL

    ./build_rom.sh
done
    

